//-----------------------------------------------------------------------------
//      API_1_SVE_THITS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//      Package Definition
//-----------------------------------------------------------------------------
package sim.test.access.api_1_sve_thits;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.access.*;
import sim.toolkit.* ;
import javacard.framework.* ;

import sim.test.util.* ;

/**
 * Test Area : sim.access.SIMViewException.throwIt(short reason) method
 *
 * Applet is triggered on EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 29/11/00
 * @autor 3GPP T3 SWG API
 *
 * @see sim.access.SIMViewException
 *
 */
public class API_1_SVE_THITS_1 extends TestToolkitApplet implements ToolkitInterface, ToolkitConstants
{

  /**
   * Constructor of the applet
   */
  private ToolkitRegistry obReg ;


  public API_1_SVE_THITS_1()
  {
  }


  /**
   * Method called by the JCRE at the installation of the applet
  */
  public static void install(byte bArray[], short bOffset, byte bLength)
  {
    // Create a new applet instance
    API_1_SVE_THITS_1 thisApplet = new API_1_SVE_THITS_1();

    // Register the new applet instance to the JCRE
    thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

	// Initialise the data of the test applet
    thisApplet.init();
  }


  /**
   * Method called by the SIM Toolkit Framework
   */
  public void processToolkit(byte event) {
    // Number of tests
    byte testCaseNb = (byte)0;
    // Result of tests
    boolean bRes = false;

      // --------------------------------------------
      // Test Case 1 : Throws the JCRE instance of
      // SIMViewException with the specified reason 0
      testCaseNb = (byte)1;
	  bRes = false ;

      try {
        SIMViewException.throwIt((short) 0);
      }
	  catch (SIMViewException ex) {
		  if( ex.getReason() == 0 ){
          	bRes = true ;
        	}
      }
      catch( Throwable ex ) {
        // Error, throw not as a SIMViewException
        bRes = false ;
      }
      reportTestOutcome(testCaseNb, bRes) ;


      // --------------------------------------------
      // Test Case 2 : Throws the JCRE instance of
      // SIMViewException with the specified reason 1
      testCaseNb = (byte)2;
	  bRes = false ;

      try {
        SIMViewException.throwIt((short) 1);
      }
	  catch (SIMViewException ex) {
		  if( ex.getReason() == 1 ){
          	bRes = true ;
        	}
      }
      catch( Throwable ex ) {
        // Error, throw not as a SIMViewException
        bRes = false ;
      }
      reportTestOutcome(testCaseNb, bRes) ;



      // --------------------------------------------
      // Test Case 3 : Throws the JCRE instance of
      // SIMViewException with the specified reason 15
      testCaseNb = (byte)3;
	  bRes = false ;

      try {
        SIMViewException.throwIt((short) 15);
      }
	  catch (SIMViewException ex) {
		  if( ex.getReason() == 15 ){
          	bRes = true ;
        	}
      }
      catch( Throwable ex ) {
        // Error, throw not as a SIMViewException
        bRes = false ;
      }
      reportTestOutcome(testCaseNb, bRes) ;


      // --------------------------------------------
      // Test Case 4 : SIMViewException extends
      // javacard.framework.CardRuntimeException reson 0
      testCaseNb = (byte) 0x04 ;
	  bRes = false ;

      try {
        SIMViewException.throwIt((short) 0);
      }
	  catch (CardRuntimeException ex) {
		  if( ex.getReason() == 0 ){
          	bRes = true ;
        	}
      }
      catch( Throwable ex ) {
        // Error, throw not as a CardRuntimeException
        bRes = false ;
      }
      reportTestOutcome(testCaseNb, bRes) ;


      // --------------------------------------------
      // Test Case 5 : SIMViewException extends
      // javacard.framework.CardRuntimeException reson 1
      testCaseNb = (byte) 0x05 ;
	  bRes = false ;

      try {
        SIMViewException.throwIt((short) 1);
      }
	  catch (CardRuntimeException ex) {
		  if( ex.getReason() == 1 ){
          	bRes = true ;
        	}
      }
      catch( Throwable ex )
      {
        // Error, throw not as a CardRuntimeException
        bRes = false ;
      }
      reportTestOutcome(testCaseNb, bRes) ;



      // --------------------------------------------
      // Test Case 6 : SIMViewException extends
      // javacard.framework.CardRuntimeException reson 15
      testCaseNb = (byte) 0x06 ;
	  bRes = false ;

      try {
        SIMViewException.throwIt((short) 15);
      }
	  catch (CardRuntimeException ex) {
		  if( ex.getReason() == 15 ){
          	bRes = true ;
        	}
      }
      catch( Throwable ex ) {
        // Error, throw not as a CardRuntimeException
        bRes = false ;
      }
      reportTestOutcome(testCaseNb, bRes) ;

      // End of the Test Sequence

  }
}
