//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.access.api_1_svw_redrsbs_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.access.*;
import sim.toolkit.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;


public class API_1_SVW_REDRSBS_BSS_1 extends TestToolkitApplet {

    static SIMView theSimView;

    final static short RESP_BUFFER_LENGTH = (short)20;

    static byte[] resp = new byte[RESP_BUFFER_LENGTH];
    static byte[] nullBuffer = null;

    final static byte[] RESP_TESTCASE01 = {
        (byte)0x55, (byte)0x55, (byte)0x55, (byte)0x55, (byte)0x55, 
        (byte)0xFF
    };

    /**
     * The Constructor registers the application for the Event.
     */
    private API_1_SVW_REDRSBS_BSS_1() {
        
        // Get a reference to the SIM View.
        theSimView = SIMSystem.getTheSIMView();
        
    }

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        API_1_SVW_REDRSBS_BSS_1 testApp = new API_1_SVW_REDRSBS_BSS_1();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }

    /**
     * This method will be used to trigger the tests.
     * The application will be triggered by an Formatted SMS PP download event.
     * @param event 
     */
    public void processToolkit (byte event) throws ToolkitException {

        short result = 0;
        byte mode = 0;
        short recNumber = 0;
        short recOffset = 0;
        short respOffset = 0;
        short respLength = 0;

        if (event == EVENT_FORMATTED_SMS_PP_ENV) {

            /*--------------------------------------------------------------
             * TEST CASE 01: No EF selected
             *------------------------------------------------------------*/
            try {
                recNumber = 1;
                mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;
                recOffset = 0;
                respOffset = 0;
                respLength = 10;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);            
                reportTestFailure((byte)TestConstants.TESTCASE01);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE01, 
                        sve.getReason() == SIMViewException.NO_EF_SELECTED);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }

            /*--------------------------------------------------------------
             * TEST CASE 02: Read Absolute and Current from Linear 
             * Fixed EF
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_DF_SIMTEST);
                theSimView.select(TestConstants.FID_EF_LARU);

                // Record pointer not set.
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_NEXT;
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, resp, 
                                         respOffset, respLength);
                if ((resp[0] != 0x55) || (resp[1] != 0x55) || 
                    (resp[2] != 0x55) || (resp[3] != 0x55)) {
                    UserException.throwIt((short)0);
                }

                recNumber = 2;
                mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                        respOffset, respLength);
                if ((resp[0] != (byte)0xAA) || (resp[1] != (byte)0xAA) || 
                    (resp[2] != (byte)0xAA) || (resp[3] != (byte)0xAA)) {
                    UserException.throwIt((short)0);
                }

                recNumber = 1;
                theSimView.readRecord(recNumber, mode, recOffset, resp, 
                                         respOffset, respLength);
                if ((resp[0] != 0x55) || (resp[1] != 0x55) || 
                    (resp[2] != 0x55) || (resp[3] != 0x55)) {
                    UserException.throwIt((short)0);
                }

                // 6
                recNumber = 0;
                resp[0] = resp[1] = resp[2] = resp[3] = 0x00;
                theSimView.readRecord(recNumber, mode, recOffset, resp, 
                                         respOffset, respLength);
                if ((resp[0] != 0x55) || (resp[1] != 0x55) || 
                    (resp[2] != 0x55) || (resp[3] != 0x55)) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE02);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE02);
            }
        
            /*--------------------------------------------------------------
             * TEST CASE 03: Read Next from Linear Fixed EF
             *------------------------------------------------------------*/
            try {
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_NEXT;
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, resp, 
                                        respOffset, respLength);
                if ((resp[0] != (byte)0xAA) || (resp[1] != (byte)0xAA) || 
                    (resp[2] != (byte)0xAA) || (resp[3] != (byte)0xAA)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE03);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE03);
            }

            /*--------------------------------------------------------------
             * TEST CASE 04: Read Next from Linear Fixed EF
             *------------------------------------------------------------*/
            try {
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_NEXT;
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);                    	
                reportTestFailure((byte)TestConstants.TESTCASE04);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE04, 
                        sve.getReason() == SIMViewException.RECORD_NUMBER_NOT_AVAILABLE);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE04);
            }
        
            /*--------------------------------------------------------------
             * TEST CASE 05: Read Previous from Linear Fixed EF
             *------------------------------------------------------------*/
            try {
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_PREVIOUS;
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                      respOffset, respLength);
                if ((resp[0] != 0x55) || (resp[1] != 0x55) || 
                    (resp[2] != 0x55) || (resp[3] != 0x55)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE05);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE05);
            }

            /*--------------------------------------------------------------
             * TEST CASE 06: Read Previous from Linear Fixed EF
             *------------------------------------------------------------*/
            try {
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_PREVIOUS;
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);                    	
                reportTestFailure((byte)TestConstants.TESTCASE06);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE06, 
                        sve.getReason() == SIMViewException.RECORD_NUMBER_NOT_AVAILABLE);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE06);
            }

            /*--------------------------------------------------------------
             * TEST CASE 07: Read Absolute and Current from Cyclic EF
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_CARU);

                //2
                recNumber = 2;
                mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;
                recOffset = 0;
                respOffset = 0;
                respLength = 3;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                      respOffset, respLength);

                if ((resp[0] != (byte)0xAA) || (resp[1] != (byte)0xAA) || 
                    (resp[2] != (byte)0xAA)) {
                    UserException.throwIt((short)0);
                }
                
                //3
                recNumber = 1;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                      respOffset, respLength);

                if ((resp[0] != 0x55) || (resp[1] != 0x55) || 
                    (resp[2] != 0x55)) {
                    UserException.throwIt((short)0);
                }

                //4
                recNumber = 0;
                resp[0] = resp[1] = resp[2] = 0x00;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                      respOffset, respLength);

                if ((resp[0] != 0x55) || (resp[1] != 0x55) || 
                    (resp[2] != 0x55)) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE07);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE07);
            }

            /*--------------------------------------------------------------
             * TEST CASE 08: Read Next from Cyclic EF
             *------------------------------------------------------------*/
            try {
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_NEXT;
                recOffset = 0;
                respOffset = 0;
                respLength = 3;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                      respOffset, respLength);

                if ((resp[0] != (byte)0xAA) || (resp[1] != (byte)0xAA) || 
                    (resp[2] != (byte)0xAA)) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE08);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE08);
            }

            /*--------------------------------------------------------------
             * TEST CASE 09: Read Next from Cyclic EF
             *------------------------------------------------------------*/
            try {
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_NEXT;
                recOffset = 0;
                respOffset = 0;
                respLength = 3;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                      respOffset, respLength);

                if ((resp[0] != (byte)0x55) || (resp[1] != (byte)0x55) || 
                    (resp[2] != (byte)0x55)) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE09);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE09);
            }

            /*--------------------------------------------------------------
             * TEST CASE 10: Read Previous from Cyclic EF
             *------------------------------------------------------------*/
            try {
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_PREVIOUS;
                recOffset = 0;
                respOffset = 0;
                respLength = 3;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                      respOffset, respLength);

                if ((resp[0] != (byte)0xAA) || (resp[1] != (byte)0xAA) || 
                    (resp[2] != (byte)0xAA)) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE10);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE10);
            }

            /*--------------------------------------------------------------
             * TEST CASE 11: Read Previous from Cyclic EF
             *------------------------------------------------------------*/
            try {
                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_PREVIOUS;
                recOffset = 0;
                respOffset = 0;
                respLength = 3;
                theSimView.readRecord(recNumber, mode, recOffset, resp,
                                      respOffset, respLength);

                if ((resp[0] != (byte)0x55) || (resp[1] != (byte)0x55) || 
                    (resp[2] != (byte)0x55)) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE11);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE11);
            }

            /*--------------------------------------------------------------
             * TEST CASE 12: Read Absolute from Linear Fixed EF 
             * beyond Records
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_LARU);
                recNumber = (short)-1;
                mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;                    
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                try {
                    theSimView.readRecord(recNumber, mode, recOffset, resp, 
                                            respOffset, respLength);                    	
                    UserException.throwIt((short)0);
                } catch (SIMViewException sve) {
                    if (sve.getReason() != SIMViewException.RECORD_NUMBER_NOT_AVAILABLE)
                        UserException.throwIt((short)0);
                }

                recNumber = 3;
                try {
                    theSimView.readRecord(recNumber, mode, recOffset, resp, 
                                            respOffset, respLength);                    	
                    UserException.throwIt((short)0);
                } catch (SIMViewException sve) {
                    if (sve.getReason() != SIMViewException.RECORD_NUMBER_NOT_AVAILABLE)
                        UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE12);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE12);
            }

            /*--------------------------------------------------------------
             * TEST CASE 13: No current record in linear fixed EF, 
             * read current
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_LARU);

                // No curr rec
                recNumber = 0;              // curr rec
                mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);                    	
                reportTestFailure((byte)TestConstants.TESTCASE13);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE13, 
                        sve.getReason() == SIMViewException.RECORD_NUMBER_NOT_AVAILABLE);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE13);
            }

            /*--------------------------------------------------------------
             * TEST CASE 14: recOffset < 0
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_LARU);

                recNumber = 1;
                mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;
                recOffset = (short)-1;
                respOffset = 0;
                respLength = 4;
                 theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);                    	
                reportTestFailure((byte)TestConstants.TESTCASE14);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE14, 
                        sve.getReason() == SIMViewException.OUT_OF_RECORD_BOUNDARIES);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE14);
            }

            /*--------------------------------------------------------------
             * TEST CASE 15: recOffset + respLength > Record Length 
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_LARU);

                recNumber = 1;
                mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;
                recOffset = 2;
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);                    	
                reportTestFailure((byte)TestConstants.TESTCASE15);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE15, 
                        sve.getReason() == SIMViewException.OUT_OF_RECORD_BOUNDARIES);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE15);
            }

            /*--------------------------------------------------------------
             * TEST CASE 16: Reading with invalid mode 
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_LARU);

                recNumber = 0;
                mode = 1;
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                try {
                    theSimView.readRecord(recNumber, mode, recOffset, resp, 
                                            respOffset, respLength);                    	
                    UserException.throwIt((short)0);
                } catch (SIMViewException sve) {
                    if (sve.getReason() != SIMViewException.INVALID_MODE)
                        UserException.throwIt((short)0);
                }

                mode = 5;
                try {
                    theSimView.readRecord(recNumber, mode, recOffset, resp, 
                                            respOffset, respLength);                    	
                    UserException.throwIt((short)0);
                } catch (SIMViewException sve) {
                    if (sve.getReason() != SIMViewException.INVALID_MODE)
                        UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE16);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE16);
            }


            /*--------------------------------------------------------------
             * TEST CASE 17: resp is null
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_LARU);

                recNumber = 0;
                mode = SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT;
                recOffset = 0;
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, nullBuffer, 
                                      respOffset, respLength);
                reportTestFailure((byte)TestConstants.TESTCASE17);
            } catch (NullPointerException npe) {
                reportTestSuccess((byte)TestConstants.TESTCASE17);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE17);
            }

            /*--------------------------------------------------------------
             * TEST CASE 18: respOffset < 0
             *-----------------------------------------------------------*/
            try {
                respOffset = (short)-1;
                respLength = 10;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);
                reportTestFailure((byte)TestConstants.TESTCASE18);
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                reportTestSuccess((byte)TestConstants.TESTCASE18);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE18);
            }

            /*--------------------------------------------------------------
             * TEST CASE 19: respLength < 0
             *------------------------------------------------------------*/
            try {
                respOffset = 0;
                respLength = (short)-1;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);
                reportTestFailure((byte)TestConstants.TESTCASE19);
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                reportTestSuccess((byte)TestConstants.TESTCASE19);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE19);
            }

            /*--------------------------------------------------------------
             * TEST CASE 20: respOffset + respLength > resp.length
             *------------------------------------------------------------*/
            try {
                respOffset = 10;
                respLength = 11;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);
                reportTestFailure((byte)TestConstants.TESTCASE20);
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                reportTestSuccess((byte)TestConstants.TESTCASE20);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE20);
            }

            /*--------------------------------------------------------------
             * TEST CASE 21: EF is neither Cyclic nor Linear Fixed
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_DF_SIMTEST);
                theSimView.select(TestConstants.FID_EF_TNU);
                respOffset = 0;
                respLength = 4;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);
                reportTestFailure((byte)TestConstants.TESTCASE21);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE21, 
                        sve.getReason() == SIMViewException.FILE_INCONSISTENT);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE21);
            }

            /*--------------------------------------------------------------
             * TEST CASE 22: Access condition not fulfilled
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_CNR);
                respLength = 3;
                theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);                    	

                reportTestFailure((byte)TestConstants.TESTCASE22);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE22, 
                        sve.getReason() == SIMViewException.AC_NOT_FULFILLED);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE22);
            }

            /*--------------------------------------------------------------
             * TEST CASE 23: EF is invalidated
             *------------------------------------------------------------*/
            try {
                theSimView.select(TestConstants.FID_EF_CNU);

                theSimView.invalidate();

                try {
                    theSimView.readRecord(recNumber, mode, recOffset, resp, respOffset, respLength);                    	
                    UserException.throwIt((short)0);
                } catch (SIMViewException sve) {
                    if (sve.getReason() != SIMViewException.INVALIDATION_STATUS_CONTRADICTION)
                        UserException.throwIt((short)0);
                } finally {
                    theSimView.rehabilitate();
                }

                reportTestSuccess((byte)TestConstants.TESTCASE23);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE23);
            }

        } // end if
    }
}
