//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.access.api_1_svw_slcts_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import sim.access.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;


public class API_1_SVW_SLCTS_BSS_1 extends TestToolkitApplet {

    private SIMView theSIMView;

    public final static byte[] fileICCID = {(byte) 0x2f, (byte) 0xe2, (byte) 0x04};
    public final static byte[] dfGSM = {(byte) 0x7f, (byte) 0x20, (byte) 0x02};
    public final static byte[] dfTELECOM = {(byte) 0x7f,(byte) 0x10, (byte) 0x02};
    public final static byte[] fileACM = {(byte) 0x6f, (byte) 0x39, (byte) 0x04};
    public final static byte[] fileFDN = {(byte) 0x6f, (byte) 0x3b, (byte) 0x04};

    public final static short OFF_ID = (short)4;

    public static byte[] normalBuffer = new byte[34];
    public static byte[] nullBuffer = null;
    public static byte[] fci;
    public static byte[] data1 = {(byte) 0x01, (byte) 0x02, (byte) 0x03};
    public static byte[] data2 = new byte[50];


    /**
     * The Constructor register the application for the Event.
     */
    private API_1_SVW_SLCTS_BSS_1() {
        
        // Get a reference to the SIM View.
        theSIMView = SIMSystem.getTheSIMView();
        
    }

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        API_1_SVW_SLCTS_BSS_1 testApp = new API_1_SVW_SLCTS_BSS_1();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }


    /**
     * @param event 
     * In the processToolkit-function the incomming data will be processed. 
     * In accordance to the tags of the TLVs, there will be processed a 
     * GetInkeyCommand or an UPDATECommand. The GetInkeyCommand will be also 
     * used to test the of the ProactiveResponseHandler.
     */
    public void processToolkit (byte event) throws ToolkitException {
        
        EnvelopeHandler envHdlr;
        short fciOffset = 0;
        short fciLength = 0;
        short result = 0;
    
        if (event == EVENT_FORMATTED_SMS_PP_ENV) {

            /*------------------------------------------------------------------
             * TEST CASE 01:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 20;
                result = theSIMView.select(SIMView.FID_EF_ICCID, fci, fciOffset, fciLength);
                if ((result > fciLength)||(Util.arrayCompare(fileICCID, (short)0, fci, OFF_ID, 
                    (short)fileICCID.length)!=0)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE01);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }
                
            /*------------------------------------------------------------------
             * TEST CASE 02:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 13;
                result = theSIMView.select(SIMView.FID_EF_ICCID, fci, fciOffset, fciLength);
                if ((result != fciLength)||(Util.arrayCompare(fileICCID, (short)0, 
                            fci, OFF_ID, (short)fileICCID.length)!=0)) {
                    UserException.throwIt((short)0);
                }
                    reportTestSuccess((byte)TestConstants.TESTCASE02);
            } catch (Exception e) {
                   reportTestFailure((byte)TestConstants.TESTCASE02);
            }

            
            /*------------------------------------------------------------------
             * TEST CASE 03:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 7;
                result = theSIMView.select(SIMView.FID_DF_GSM, fci, fciOffset, fciLength);
                if ((result != fciLength)||(Util.arrayCompare(dfGSM, (short)0, 
                        fci, OFF_ID, (short)dfGSM.length)!=0)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE03);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE03);
            }

            
            /*------------------------------------------------------------------
             * TEST CASE 04:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 20;
                result = theSIMView.select(SIMView.FID_EF_ACM, fci, fciOffset, fciLength);
                if ((result > fciLength) || (result < (short) 15) ||
                    (Util.arrayCompare(fileACM, (short)0, fci, OFF_ID, (short)fileACM.length)!=0) ||
                    (fci[14]!=(short)3)) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE04);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE04);
            }

            /*------------------------------------------------------------------
             * TEST CASE 05:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 34;
                result = theSIMView.select(SIMView.FID_MF, fci, fciOffset, fciLength);
                if ((result > fciLength)||(result < (short) 22)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE05);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE05);
            }

            /*------------------------------------------------------------------
             * TEST CASE 06:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fci[0] = fci[1] = (byte)0x05;
                fciOffset = 2;
                fciLength = 20;
                result = theSIMView.select(SIMView.FID_DF_TELECOM, fci, fciOffset, fciLength);
                if ((result != fciLength)||(fci[0]!= 0x05)||(fci[1]!= 0x05)||
                    (Util.arrayCompare(dfTELECOM, (short)0, fci, 
                    (short)(OFF_ID + (short) 2), (short)dfTELECOM.length)!=0)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE06);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE06);
            }

            /*------------------------------------------------------------------
             * TEST CASE 07:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 15;
                result = theSIMView.select(SIMView.FID_EF_FDN, fci, fciOffset, fciLength);
                if ((result != fciLength)||
                    (Util.arrayCompare(fileFDN, (short)0, fci, OFF_ID, (short)fileFDN.length)!=0)||
                      (fci[14] != (short)28)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE07);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE07);
            }

            /*------------------------------------------------------------------
             * TEST CASE 08:
             *----------------------------------------------------------------*/
            try {
                fci = nullBuffer;
                fciOffset = 0;
                fciLength = 15;
                result = theSIMView.select(SIMView.FID_EF_FDN, fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE08);
            } catch (NullPointerException npe) {
                reportTestSuccess((byte)TestConstants.TESTCASE08);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE08);
            }

            /*------------------------------------------------------------------
             * TEST CASE 09:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = -1;
                fciLength = 15;
                result = theSIMView.select(SIMView.FID_EF_FDN, fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE09);
            } catch (ArrayIndexOutOfBoundsException aiofbe) {
                reportTestSuccess((byte)TestConstants.TESTCASE09);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE09);
            }


            /*------------------------------------------------------------------
             * TEST CASE 10:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = -1;
                result = theSIMView.select(SIMView.FID_EF_FDN, fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE10);
            } catch (ArrayIndexOutOfBoundsException aiofbe) {
                reportTestSuccess((byte)TestConstants.TESTCASE10);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE10);
            }

            /*------------------------------------------------------------------
             * TEST CASE 11:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 20;
                fciLength = 15;
                result = theSIMView.select(SIMView.FID_EF_FDN, fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE11);
            } catch (ArrayIndexOutOfBoundsException aiofbe) {
                reportTestSuccess((byte)TestConstants.TESTCASE11);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE11);
            }

            /*------------------------------------------------------------------
             * TEST CASE 12:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 34;
                fciLength = 1;
                result = theSIMView.select(SIMView.FID_EF_FDN, fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE12);
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                reportTestSuccess((byte)TestConstants.TESTCASE12);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE12);
            }

            /*------------------------------------------------------------------
             * TEST CASE 13:
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 15;
                result = theSIMView.select(SIMView.FID_MF, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_DF_TELECOM, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_DF_GRAPHICS, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_DF_TELECOM, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_DF_GRAPHICS, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_MF, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_DF_GSM, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_DF_TELECOM, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_DF_TELECOM, fci, fciOffset, fciLength);
                reportTestSuccess((byte)TestConstants.TESTCASE13);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE13);
            }

            /*------------------------------------------------------------------
             * TEST CASE 14: EF not selected after MF/DF selection 
             *----------------------------------------------------------------*/
            try {
                result = theSIMView.select(SIMView.FID_MF, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_EF_ICCID, fci, fciOffset, fciLength);
                result = theSIMView.select(SIMView.FID_MF, fci, fciOffset, fciLength);

                result = theSIMView.readBinary((short)0, data2, (short)0, (short)data2.length);

                reportTestFailure((byte)TestConstants.TESTCASE14);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE14, 
                        sve.getReason() == SIMViewException.NO_EF_SELECTED);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE14);
            }
            
            /*------------------------------------------------------------------
             * TEST CASE 15: No selection of  non-reachable file
             *----------------------------------------------------------------*/
            try {
                result = theSIMView.select(SIMView.FID_MF, fci, fciOffset, fciLength);

                result = theSIMView.select(SIMView.FID_EF_ACM, fci, fciOffset, fciLength);

                reportTestFailure((byte)TestConstants.TESTCASE15);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE15, 
                        sve.getReason() == SIMViewException.FILE_NOT_FOUND);
            } catch (Exception e) {
                    reportTestFailure((byte)TestConstants.TESTCASE15);
            }

            /*------------------------------------------------------------------
             * TEST CASE 16: No record is selected after selecting linear fixed EF
             *----------------------------------------------------------------*/
            try {
                theSIMView.select(SIMView.FID_MF, fci, fciOffset, fciLength);
                theSIMView.select(TestConstants.FID_DF_SIMTEST, fci, fciOffset, fciLength);
                theSIMView.select(TestConstants.FID_EF_LARU, fci, fciOffset, fciLength);

                result = theSIMView.readRecord((short)0, SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT, 
                                               (short)0, data2, (short)0, (short)1);

                reportTestFailure((byte)TestConstants.TESTCASE16);
            } catch (SIMViewException sve) {
                reportTestOutcome((byte)TestConstants.TESTCASE16, 
                        sve.getReason() == SIMViewException.RECORD_NUMBER_NOT_AVAILABLE);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE16);
            }

            /*------------------------------------------------------------------
             * TEST CASE 17: Record pointer in selected cyclic EF 
             *----------------------------------------------------------------*/
            try {
                theSIMView.select(SIMView.FID_MF, fci, fciOffset, fciLength);
                theSIMView.select(TestConstants.FID_DF_SIMTEST, fci, fciOffset, fciLength);
                theSIMView.select(TestConstants.FID_EF_CARU, fci, fciOffset, fciLength);

                data1[0] = 1; 
                data1[1] = 2; 
                data1[2] = 3;

                theSIMView.updateRecord((short)0, SIMView.REC_ACC_MODE_PREVIOUS, (short)0, data1, 
                                     (short)0,( short)3);

                theSIMView.select(TestConstants.FID_EF_CARU, fci, fciOffset, fciLength);

                theSIMView.readRecord((short)0, SIMView.REC_ACC_MODE_ABSOLUTE_CURRENT, (short)0, data2,
                                            (short)0,(short)3);
                if (Util.arrayCompare(data1, (short)0, data2, (short)0, (short)3)!=0) {
                    UserException.throwIt((short)0);
                }

                reportTestSuccess((byte)TestConstants.TESTCASE17);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE17);
            }

        } // end if  (event...)
    }
}
