//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.access.api_1_svw_stat_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.access.*;
import sim.toolkit.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;

public class API_1_SVW_STAT_BSS_1 extends TestToolkitApplet {

    private static SIMView theSIMView;

    public final static byte[] MF = {(byte) 0x3F, (byte) 0x00, (byte) 0x01};
    public final static byte[] fileICCID = {(byte) 0x2f, (byte) 0xe2, (byte) 0x04};
    public final static byte[] dfGSM = {(byte) 0x7f, (byte) 0x20, (byte) 0x02};
    public final static byte[] dfTELECOM = {(byte) 0x7f,(byte) 0x10, (byte) 0x02};
    public final static byte[] efACM = {(byte) 0x6f, (byte) 0x39, (byte) 0x04};
    public final static byte[] efFDN = {(byte) 0x6f, (byte) 0x3b, (byte) 0x04};

    public final static short OFF_ID = (short)4;

    public static byte[] normalBuffer = new byte[100];
    public static byte[] nullBuffer = null;
    public static byte[] fci;
    public static byte[] fci2 = new byte[100];


    /**
     * The Constructor register the application for the Event.
     */
    private API_1_SVW_STAT_BSS_1() {

        // Get a reference to the SIM View.
        theSIMView = SIMSystem.getTheSIMView();
        
    }

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        API_1_SVW_STAT_BSS_1 testApp = new API_1_SVW_STAT_BSS_1();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }


    /**
     * @param event 
     * In the processToolkit-function the incomming data will be processed. 
     * In accordance to the tags of the TLVs, there will be processed a 
     * GetInkeyCommand or an UPDATECommand. The GetInkeyCommand will be also 
     * used to test the of the ProactiveResponseHandler.
     */
    public void processToolkit (byte event) throws ToolkitException {
        
        EnvelopeHandler envHdlr;
        short fciOffset = 0;
        short fciLength = 0;
        short result = 0;
        short result2 = 0;
    
        if (event == EVENT_FORMATTED_SMS_PP_ENV) {

            /*------------------------------------------------------------------
             * TEST CASE 01: Status of MF
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 7;
                result = theSIMView.status(fci, fciOffset, fciLength);
                if ((result != fciLength)||(Util.arrayCompare(MF, (short)0, fci, OFF_ID, 
                    (short)MF.length)!=0)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE01);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }
        
            /*------------------------------------------------------------------
             * TEST CASE 02: Status after select EF ICCID in MF
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = 34;
                result = theSIMView.select(SIMView.FID_DF_GSM, fci, fciOffset, fciLength);
                if ((result < (short)22)||(result > fciLength)) {
                    UserException.throwIt((short)0);
                }

                result2 = theSIMView.status(fci2, fciOffset, fciLength);
                if ((result != result2) || (Util.arrayCompare(fci, (short)0, 
                                            fci2, (short)0, (short)result)!=0)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE02);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE02);
            }
        
            /*------------------------------------------------------------------
             * TEST CASE 03: Status of DF Telecom
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                result = theSIMView.select(SIMView.FID_DF_TELECOM, fci, fciOffset, fciLength);
                if ((result < (short)22)||(result > fciLength)) {
                    UserException.throwIt((short)0);
                }
                fciOffset = 0;
                fciLength = 100;
                result = theSIMView.status(fci, fciOffset, fciLength);
                if ((result < (short)22)||(result > fciLength) ||
                    (result != fci[12] + (short) 13) ||
                    (Util.arrayCompare(fci, OFF_ID, dfTELECOM, (short)0, (short)2)!=0)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE03);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE03);
            }

            /*------------------------------------------------------------------
             * TEST CASE 04: Status DF Telecom
             *----------------------------------------------------------------*/
            try {
                fciOffset = 0;
                fciLength = 7;
                result = theSIMView.status(fci, fciOffset, fciLength);
                if ((result != fciLength) ||
                    (Util.arrayCompare(fci, OFF_ID, dfTELECOM, (short)0, (short)2)!=0)) {
                    UserException.throwIt((short)0);
                }
                reportTestSuccess((byte)TestConstants.TESTCASE04);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE04);
            }
          
            /*------------------------------------------------------------------
             * TEST CASE 05: fci is null
             *----------------------------------------------------------------*/
            try {
                fci = nullBuffer;
                fciOffset = 0;
                fciLength = 34;
                result = theSIMView.status(fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE05);
            } catch (NullPointerException npe) {
                    reportTestSuccess((byte)TestConstants.TESTCASE05);
            } catch (Exception e) {
                    reportTestFailure((byte)TestConstants.TESTCASE05);
            }

            /*------------------------------------------------------------------
             * TEST CASE 06: fciOffset < 0
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = -1;
                fciLength = 34;
                result = theSIMView.status(fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE06);
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                    reportTestSuccess((byte)TestConstants.TESTCASE06);
            } catch (Exception e) {
                    reportTestFailure((byte)TestConstants.TESTCASE06);
            }

            /*------------------------------------------------------------------
             * TEST CASE 07: fciLength < 0
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = 0;
                fciLength = -1;
                result = theSIMView.status(fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE07);
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                    reportTestSuccess((byte)TestConstants.TESTCASE07);
            } catch (Exception e) {
                    reportTestFailure((byte)TestConstants.TESTCASE07);
            }

            /*------------------------------------------------------------------
             * TEST CASE 08: fciOffset + fciLength > fci.length
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = (short)(fci.length - 1);
                fciLength = 15;
                result = theSIMView.status(fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE08);
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                    reportTestSuccess((byte)TestConstants.TESTCASE08);
            } catch (Exception e) {
                    reportTestFailure((byte)TestConstants.TESTCASE08);
            }

            /*------------------------------------------------------------------
             * TEST CASE 09: fciOffset >= fci.length
             *----------------------------------------------------------------*/
            try {
                fci = normalBuffer;
                fciOffset = (short)(fci.length + 1);
                fciLength = 1;
                result = theSIMView.status(fci, fciOffset, fciLength);
                reportTestFailure((byte)TestConstants.TESTCASE09);
            } catch (ArrayIndexOutOfBoundsException aioobe) {
                reportTestSuccess((byte)TestConstants.TESTCASE09);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE09);
            }

        } // end if
    }
}
