//-----------------------------------------------------------------------------
//    FWK_API_TMID_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_api_tmid;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : Timer Id between Applets
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 03/12/01
 *
 */
public class FWK_API_TMID_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */

	static byte instanceNumber = (byte) 0x00;
	static byte firstInstanceTimerId = (byte) 0x00;
	
    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public FWK_API_TMID_1 () 
    {
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        FWK_API_TMID_1  thisApplet = new FWK_API_TMID_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();
		
		// Allocate a timer
		byte timerId = thisApplet.obReg.allocateTimer();

		if (instanceNumber == 0)
		{
			firstInstanceTimerId = timerId;
		}

		instanceNumber++;
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes = false ;

		// --------------------------------------------
		// Test Case 1 : Verify the impossibility of releasing another applet timer
		testCaseNb = (byte) 1 ;
		
		bRes = false ;

		try {
			obReg.releaseTimer(firstInstanceTimerId);
		}
		catch (ToolkitException e)    {
			// Check the exception is the good one and the timer has been allocated
			if ( 
				(e.getReason() == ToolkitException.INVALID_TIMER_ID)
			   && (firstInstanceTimerId != 0)
			   )
			   bRes = true;
		}
		catch (Exception e)    {
		}

		reportTestOutcome(testCaseNb, bRes) ;

	}
}
