//-----------------------------------------------------------------------------
//    FWK_APT_EPDW_2.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_apt_epdw;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Applet Triggering
 *
 * Applet is triggered on Install (Install, all events
 *
 * @version 0.0.1 - 15/11/01
 *
 */

 public class FWK_APT_EPDW_2 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;
     private boolean bRes;


    //Constructor of the applet

    public FWK_APT_EPDW_2(){
        //register to EVENT PROFILE DOWNLOAD
        obReg.setEvent(EVENT_PROFILE_DOWNLOAD);
    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_APT_EPDW_2 thisApplet = new FWK_APT_EPDW_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

      if(event==EVENT_PROFILE_DOWNLOAD){	
        bRes=false;
        switch(testCaseNb){

            case (byte)0x00:
                //TEST CASE 1: THE APPLET IS TRIGGERED
                testCaseNb=(byte)0x01;
                bRes=true;
                //create the table of results
                reportTestOutcome(testCaseNb,bRes);
           break;

           case (byte)0x01:

               //TEST CASE 2: THE APPLET IS UNREGISTERED TO THE EVENT
               testCaseNb=(byte)0x02;
               try{
                    obReg.clearEvent(EVENT_PROFILE_DOWNLOAD);
                    bRes=true;
               }
               catch(Exception e){
                    bRes=false;
               }
               //create the table of results
               reportTestOutcome(testCaseNb,bRes);
               //This case is only to put 0xCC in the test case 3.
               reportTestOutcome((byte)0x03,true);

           break;

           case (byte)0x02:
                //if the applet is triggered then 0x00 is stored in the test case 3
                testCaseNb=(byte)0x03;
                //create the table of results
                reportTestOutcome(testCaseNb,false);
        }
      }
    }

 }