//-----------------------------------------------------------------------------
//    FWK_ERP_EUEN_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_erp_euen;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * Test Area : sim.toolkit.framework
 *
 * Chapter: Envelope Response Posting
 * Test Area inside the chapter: EVENT_UNRECOGNIZED_ENVELOPE
 *
 *
 * @version 0.0.1 - 10/01/02
 * @author 3GPP T3 SWG API
 *
 */
public class FWK_ERP_EUEN_1 extends TestToolkitApplet
{
	private static final short BEGINNING_OF_STRING = (short)0x00;
	private static final byte[] DATA2POST = {(byte)0x0C, (byte)0xAB} ;
	byte testCaseNb = (byte) 0x00;
	byte[] buffer = new byte[25];
	private ToolkitRegistry obReg;

    /**
     * Constructor of the applet
     */
    public FWK_ERP_EUEN_1() {
		obReg = ToolkitRegistry.getEntry();

		// Triggering on EVENT_UNRECOGNIZED_ENVELOPE
		obReg.setEvent(EVENT_UNRECOGNIZED_ENVELOPE);
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength)
    {
        // Create a new applet instance
        FWK_ERP_EUEN_1 thisApplet = new FWK_ERP_EUEN_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();

    }


    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event)
    {

		// Result of each test
		boolean bRes = false;

		// Sets the test case number
		testCaseNb++;

		// Get the system instance of the EnvelopeHandler class
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

		// Get the system instance of the EnvelopeResponseHandler class
		EnvelopeResponseHandler envRespHandler = EnvelopeResponseHandler.getTheHandler();

		switch ( testCaseNb )
			{
				case (byte) 1 :
				// --------------------------------------------
				// The SIM shall post the data issued by the applet
				try {
					bRes = false;
					envRespHandler.appendArray(DATA2POST, (short)0x00, (short)DATA2POST.length);
			        envRespHandler.post(SW1_RP_ACK);
				    bRes = true;
					}
				catch (Exception e)    {
				    bRes = false;
				}
				reportTestOutcome(testCaseNb, bRes);
				break;

				case (byte) 2 :
				// --------------------------------------------
				// The SIM shall post the data issued by the applet
				try {
					bRes = false;
					envRespHandler.appendArray(DATA2POST, (short)0x00, (short)DATA2POST.length);
			        envRespHandler.post(SW1_RP_ACK);
				    bRes = true;
					}
				catch (Exception e)    {
				    bRes = false;
				}
				reportTestOutcome(testCaseNb, bRes);
				break;
			}

	}
}
