//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_fsc_cufi;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import sim.access.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;


public class FWK_FSC_CUFI_2 extends TestToolkitApplet {

    private static SIMView theSIMView;

    /**
     * The Constructor register the application for the Event.
     */
    private FWK_FSC_CUFI_2() {

        // Get a reference to the SIM View.
        theSIMView = SIMSystem.getTheSIMView();

        // Set CALL CONTROL as an activation event for the applet
        obReg.setEvent(EVENT_CALL_CONTROL_BY_SIM);
    }

    public static void install(byte[] bArray, short bOffset, byte bLength) {
        FWK_FSC_CUFI_2 testApp = new FWK_FSC_CUFI_2();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }


    /**
     * @param event
     * In the processToolkit-function the incomming data will be processed.
     */
    public void processToolkit (byte event) throws ToolkitException {

        if (event == EVENT_CALL_CONTROL_BY_SIM) {
            /*------------------------------------------------------------------
             * TEST CASE 1: No change to file context by another applet
             *----------------------------------------------------------------*/
            try {
                // (2/3) - No exception shall be thrown.
                theSIMView.select(SIMView.FID_DF_TELECOM);
                theSIMView.select(SIMView.FID_EF_ADN);
                reportTestSuccess((byte)TestConstants.TESTCASE01);
            } catch (Exception e) {
                reportTestFailure((byte)TestConstants.TESTCASE01);
            }

            /*------------------------------------------------------------------
             * TEST CASE 2: No change to file context by subscriber session
             *----------------------------------------------------------------*/
            // do nothing
            reportTestSuccess((byte)TestConstants.TESTCASE02);

            /*------------------------------------------------------------------
             * TEST CASE 3: No change by applet of subscriber session context
             *----------------------------------------------------------------*/
            // do nothing
            reportTestSuccess((byte)TestConstants.TESTCASE03);

        } // end: if (event)...
    }
}
