//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_fsc_cure;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import sim.access.*;
import javacard.framework.*;

import sim.test.util.*;
import sim.test.access.*;


public class FWK_FSC_CURE_2 extends TestToolkitApplet {

    SIMView theSimView;

    final static byte EF_CARU_RECLENGTH = (byte)3;
    final static byte[] ALL_FIVES = {(byte)0x55, (byte)0x55, (byte)0x55, (byte)0x55};

    byte[] patt2 = new byte[20];
    byte[] tmpBuffer = new byte[10];
    byte testcase = 0;

    /**
     * The Constructor registers the application for the Event.
     */
    private FWK_FSC_CURE_2() {

        // Get a reference to the SIM View.
        theSimView = SIMSystem.getTheSIMView();

        // Set CALL CONTROL as an activation event for the applet
        obReg.setEvent(EVENT_CALL_CONTROL_BY_SIM);
    }


    public static void install(byte[] bArray, short bOffset, byte bLength) {
         FWK_FSC_CURE_2 testApp = new FWK_FSC_CURE_2();

        // Register the applet with the JCRE.
        testApp.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet.
        testApp.init();
    }


    /**
     * This method will be used to trigger the tests.
     * The application will be triggered by an Formatted SMS PP download event.
     * @param event
     */
    public void processToolkit (byte event) throws ToolkitException {

        short result;
        short pattLength;
        byte mode;

        if (event==EVENT_CALL_CONTROL_BY_SIM) {

            testcase++;

            switch (testcase)
            {

              case 1:
                /*------------------------------------------------------------------
                 * TEST CASE 01: Seek without affecting another record pointer
                 *----------------------------------------------------------------*/
                try {
                  // (2/3) - No exception shall be thrown.
                  theSimView.select(TestConstants.FID_DF_SIMTEST);
                  theSimView.select(TestConstants.FID_EF_LARU);


                  mode = SIMView.SEEK_FROM_BEGINNING_FORWARD;
                  pattLength = (short)1;
                  result = theSimView.seek(mode, ALL_FIVES, (short)0, pattLength);

                  reportTestSuccess((byte)TestConstants.TESTCASE01);
                } catch (Exception e) {
                  reportTestFailure((byte)TestConstants.TESTCASE01);
                }
                break;

              case 2:
                /*------------------------------------------------------------------
                 * TEST CASE 02: updateRecord in linear fixed EF without affecting
                 *               current pointer of others.
                 *----------------------------------------------------------------*/
                try {
                  // (2/3) - No exception shall be thrown.
                  theSimView.select(TestConstants.FID_DF_SIMTEST);
                  theSimView.select(TestConstants.FID_EF_LARU);


                  mode = SIMView.REC_ACC_MODE_NEXT;
                  pattLength = (short)4;
                  theSimView.updateRecord((short)0, mode, (short)0, ALL_FIVES, (short)0, pattLength);

                  reportTestSuccess((byte)TestConstants.TESTCASE02);
                } catch (Exception e) {
                  reportTestFailure((byte)TestConstants.TESTCASE02);
                }
                break;

              case 3:
                /*------------------------------------------------------------------
                 * TEST CASE 03: readRecord in linear fixed EF without affecting
                 *               current pointer of others.
                 *----------------------------------------------------------------*/
                try {
                  // (2/3) - No exception shall be thrown.
                  theSimView.select(TestConstants.FID_DF_SIMTEST);
                  theSimView.select(TestConstants.FID_EF_LARU);

                  // read back the record and check if the result is the same
                  // (record pointer was not altered)

                  mode = SIMView.REC_ACC_MODE_NEXT;
                  pattLength = (short)4;
                  result = theSimView.readRecord((short)0, mode, (short)0, patt2, (short)0, pattLength);

                  reportTestSuccess((byte)TestConstants.TESTCASE03);
                } catch (Exception e) {
                  reportTestFailure((byte)TestConstants.TESTCASE03);
                }
                break;
            } // switch
        } // if (event)...
    }
}
