//-----------------------------------------------------------------------------
//    FWK_FWS_INDA_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.framework.fwk_fws_inda;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * Test Area : sim.toolkit.framework Framework security
 *
 * Applet is triggered on EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.3 - 14/02/02
 * @author 3GPP T3 SWG API
 *
 */
public class FWK_FWS_INDA_1 extends TestToolkitApplet
{
	private static final byte NO_TRIGGERING_IN_THIS_TEST_CASE = (byte)0x04;
	byte testCaseNb = (byte) 0x00;
	byte[] buffer = new byte[25];


    /**
     * Constructor of the applet
     */
    public FWK_FWS_INDA_1() {
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength)
    {
        // Create a new applet instance
        FWK_FWS_INDA_1 thisApplet = new FWK_FWS_INDA_1();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();

    }


    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event)
    {
		// Result of each test
		boolean bRes = false;

		// Get the system instance of the EnvelopeHandler class
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();

		// Sets the test case number
		testCaseNb++;

		short length = 0;
		short offset = 0;
		byte data = 0;

		switch ( testCaseNb )
			{
				case (byte) 1 :
				// --------------------------------------------
				// Test Case 1: data ciphered; integrity checked via cryptographic checksum
				//
				// In this test case it is checked that the checksum is verified and the data are deciphered
				// before being passed to the applet
				try {
					bRes = false;
					offset = envHdlr.getSecuredDataOffset();
					length = envHdlr.getSecuredDataLength();
					envHdlr.copyValue(offset, (byte[])buffer, (short)0x00, length);
					data = buffer [0];
				    if ((data == (byte)1) & (length == (byte)1)) {
					    bRes = true;
					}
				}
				catch (Exception e)    {
				    bRes = false;
				}
				reportTestOutcome(testCaseNb, bRes);
				break;

				case (byte) 2 :
				// --------------------------------------------
				// Test Case 2: data ciphered; integrity checked via cryptographic checksum
				//
				// In this test case it is checked that applet FWK_FWS_INDA_1 is triggered
				// instead of applet FWK_FWS_INDA_2
				try {
					bRes = false;
					offset = envHdlr.getSecuredDataOffset();
					length = envHdlr.getSecuredDataLength();
					envHdlr.copyValue(offset, (byte[])buffer, (short)0x00, length);
					data = buffer [0];
				    if ((data == (byte)2) & (length == (byte)1)) {
					    bRes = true;
					}
				}
				catch (Exception e)    {
				    bRes = false;
				}
				reportTestOutcome(testCaseNb, bRes);
				break;

				default :
				// --------------------------------------------
				// Test Case 4: data ciphered; integrity checked via cryptographic checksum
				//
				// In this test case it is checked that applet FWK_FWS_INDA_1 is NOT TRIGGERED
				// Therefore, the result is false if this piece of code is executed
				reportTestOutcome(NO_TRIGGERING_IN_THIS_TEST_CASE, false);
				break;

			}

	}
}
