//-----------------------------------------------------------------------------
//    FWK_MHA_ENHD_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------

package sim.test.framework.fwk_mha_enhd;


//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------


import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;


/**
 * Test Area: Minimum Handler Availability
 *
 * Applet is triggered on Install (Install, all events
 *
 */

 public class FWK_MHA_ENHD_2 extends TestToolkitApplet{

     private byte testCaseNb = (byte) 0x00;

     private byte[] menuEntry3={(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'3'};
     private byte[] menuEntry4={(byte)'M',(byte)'e',(byte)'n',(byte)'u',(byte)' ',(byte)'4'};
       private byte[] eventList ={EVENT_PROFILE_DOWNLOAD,EVENT_UNFORMATTED_SMS_PP_ENV,EVENT_FORMATTED_SMS_CB,EVENT_UNFORMATTED_SMS_CB,
                                EVENT_EVENT_DOWNLOAD_MT_CALL,EVENT_EVENT_DOWNLOAD_CALL_CONNECTED,EVENT_EVENT_DOWNLOAD_CALL_DISCONNECTED,
                                EVENT_EVENT_DOWNLOAD_LOCATION_STATUS,EVENT_EVENT_DOWNLOAD_USER_ACTIVITY,EVENT_EVENT_DOWNLOAD_IDLE_SCREEN_AVAILABLE,
                                EVENT_EVENT_DOWNLOAD_CARD_READER_STATUS,EVENT_EVENT_DOWNLOAD_LANGUAGE_SELECTION,EVENT_EVENT_DOWNLOAD_BROWSER_TERMINATION,
                                EVENT_UNRECOGNIZED_ENVELOPE};
     private boolean bRes;
    //Constructor of the applet
    
    private byte a;

    public FWK_MHA_ENHD_2(){

        //register to EVENT_MENU_SELECTION
        obReg.initMenuEntry(menuEntry3,(short)0,(short)menuEntry3.length,(byte)0,false,(byte)0,(short)0);
        //register to EVENT_MENU_SELECTION_HELP_REQUEST
        obReg.initMenuEntry(menuEntry4,(short)0,(short)menuEntry4.length,(byte)0,true,(byte)0,(short)0);
        //register to EVENT_TIMER_EXPIRATION
        for(a=0; a<(byte)7; a++){
       	   	obReg.allocateTimer();
       	}
       	for(a=3; a<(byte)9; a++){
       		obReg.releaseTimer((byte)a);
       	}
        //register to all event download
        obReg.setEventList(eventList,(short)0,(short)eventList.length);
        //register to EVENT_STATUS_COMMAND
        obReg.requestPollInterval((short)POLL_SYSTEM_DURATION);
        //register to EVENT_PROFILE_DOWNLOAD
    }


    //Method called by the JCRE at the installation of the applet
    public static void install (byte bArray[], short bOffset, byte bLength){

        //Create a new applet instace
        FWK_MHA_ENHD_2 thisApplet = new FWK_MHA_ENHD_2();

        // Register the new applet instance to the JCRE
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();
    }


    //Method called by the SIM Toolkit Framework

    public void processToolkit(byte event){

        bRes=false;

        switch(event){
            //for each of this events the handler is available
                //event EVENT_STATUS_COMMAND
                case EVENT_STATUS_COMMAND:
                case EVENT_PROFILE_DOWNLOAD:
                        //for this event the handler is not available
                        testCaseNb++;
                        try{
                             //get the Envelope Handler
                             EnvelopeHandler.getTheHandler();
                             bRes=false;
                        }
                        catch(ToolkitException e)
                        {
                            //Envelope Handler is not available
                            if(e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE){
                                bRes=true;
                            }
                        }

                        if(event==EVENT_PROFILE_DOWNLOAD){
                            //deregister to EVENT_PROFILE_DOWNLOAD
                            obReg.clearEvent(event);
                        }

                        reportTestOutcome(testCaseNb,bRes);
                break;

                //rest of the events
                default:
                        testCaseNb++;
                        bRes=false;
                        try{
                             //get the Envelope Handler
                             EnvelopeHandler.getTheHandler();
                             bRes=true;
                        }
                        catch(Exception e){
                            bRes=false;
                        }

                        reportTestOutcome(testCaseNb,bRes);

        }


    }

 }

