//-----------------------------------------------------------------------------
//    API_2_TKR_ATIM_3.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_atim;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.allocateTimer(byte timerID) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 15/01/01
 *
 */
public class API_2_TKR_ATIM_3 extends TestToolkitApplet
{

	// -----------------------------------------------------------------
	// Applet was installed with max timer parameter equals to 0
	// -----------------------------------------------------------------

    /**
     * Constructor of the applet
     */
    public API_2_TKR_ATIM_3() 
    {
    }

    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_TKR_ATIM_3 thisApplet = new API_2_TKR_ATIM_3();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);
        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;

        // Number of tests
        byte testCaseNb = (byte) 0x01;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

        ProactiveResponseHandler proRespHdlr = null ;
    
		short temp;

			// -----------------------------------------------------------------
			// Test Case 5 :	
			//				The applet allocates 1 timer
			//				Shall throw a ToolkitException 
			//				with reason NO_TIMER_AVAILABLE
			// -----------------------------------------------------------------
        
			testCaseNb = (byte) 1 ;
			bRes = false;

			try {    
				temp = obReg.allocateTimer();
			}
			catch (ToolkitException e) {	//Only NO_TIMER_AVAILABLE
											//should be thrown
				bRes = (e.getReason()==ToolkitException.NO_TIMER_AVAILABLE);
			}
			catch (Exception e) {
				bRes = false ;
			}

			reportTestOutcome(testCaseNb, bRes) ;
	} 
}
