//-----------------------------------------------------------------------------
//    API_2_TKR_RPOLS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_tkr_rpols;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ToolkitRegistry.requestPollInterval(short duration) method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 15/01/01
 *
 */
public class API_2_TKR_RPOLS_1 extends TestToolkitApplet
{

	private short CallNB = 0;
	/**
     * Constructor of the applet
     */
    public API_2_TKR_RPOLS_1() 
    {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_TKR_RPOLS_1 thisApplet = new API_2_TKR_RPOLS_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), (byte) bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }


    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;

        // Number of tests
        byte testCaseNb = (byte) 7;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;

        ProactiveResponseHandler proRespHdlr = null ;

		short i;

		if (event == EVENT_FORMATTED_SMS_PP_ENV) {

			CallNB++;

			switch (CallNB) {

			case (short) 1 :

				// -----------------------------------------------------------------
				// Test Case 1 :	Requesting a value between 1 and 15300 s 
				//					1-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return false
				//					2-	For duration ranging from 1 to 15300, 
				//						requestPollInterval(duration)
				//						No exception shall be thrown
				//					3-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return true
				// -----------------------------------------------------------------

				testCaseNb = (byte) 1;
				bRes = false;

				// -----------------------------------------------------------------
				//					1-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return false
				// -----------------------------------------------------------------
			
				bRes = !obReg.isEventSet(EVENT_STATUS_COMMAND);
			
				if (bRes){

				// -----------------------------------------------------------------
				//					2-	For duration ranging from 1 to 15300, 
				//						requestPollInterval(duration)
				//						No exception shall be thrown
				// -----------------------------------------------------------------

					for (i = 1;bRes && (i < 15301);i++){
				
						try{
							bRes = false;
							obReg.requestPollInterval(i);
							bRes = true;
						}
						catch (Exception e){
							bRes = false;
						}
					}
				}

				// -----------------------------------------------------------------
				//					3-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return true
				// -----------------------------------------------------------------

				bRes = bRes && obReg.isEventSet(EVENT_STATUS_COMMAND);

				reportTestOutcome(testCaseNb, bRes) ;

				// -----------------------------------------------------------------
				// Test Case 2 :	Check Applet is triggered by a STATUS command
				//					False by default
				// -----------------------------------------------------------------

				reportTestFailure((byte) 2);

				break;

			case (short) 2 :

				// -----------------------------------------------------------------
				// Test Case 3 :	Requesting POLL SYSTEM DURATION
				//					1-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return true
				//					2-	requestPollInterval(POLL_SYSTEM_DURATION)
				//						No exception shall be thrown
				//					3-	IsEventSet(EVENT_STATUS_COMMAND
				//						Shall return true
				// -----------------------------------------------------------------

				testCaseNb = (byte) 3;
				bRes = false;
		
				// -----------------------------------------------------------------
				//					1-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return true
				// -----------------------------------------------------------------
				
				bRes = obReg.isEventSet(EVENT_STATUS_COMMAND);
			
				if (bRes){
		
				// -----------------------------------------------------------------
				//					2-	requestPollInterval(POLL_SYSTEM_DURATION)
				//						No exception shall be thrown
				// -----------------------------------------------------------------

				bRes = false;

					try{
						obReg.requestPollInterval(POLL_SYSTEM_DURATION);
						bRes = true;
					}
					catch (Exception e){
						bRes = false;
					}
				}

				// -----------------------------------------------------------------
				//					3-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return true
				// -----------------------------------------------------------------
		
				bRes = bRes && obReg.isEventSet(EVENT_STATUS_COMMAND);

				reportTestOutcome(testCaseNb, bRes) ;

				// -----------------------------------------------------------------
				// Test Case 4 :	Check Applet is triggered by a STATUS command
				//					False by default
				// -----------------------------------------------------------------

				reportTestFailure((byte) 4);

				break;

			case (short) 3 :

				// -----------------------------------------------------------------
				// Test Case 5 :	Requesting invalid duration
				//					For duration ranging from 15301 to 15305, 65535
				//					and -2
				//					requestPollInterval(duration)
				//					Each time, a ToolkitException 
				//					with REGISTRY_ERROR reason code, shall be thrown
				// -----------------------------------------------------------------
		
				testCaseNb = (byte) 5;
				bRes = true;

				// 15301 to 15305
				for (i = (short) 15301;bRes && (i < (short) 15305);i++){
				
					bRes = false;			
					try{
						obReg.requestPollInterval((short) i);
					}
					catch (ToolkitException e){
						bRes = (e.getReason()==ToolkitException.REGISTRY_ERROR);
					}
					catch (Exception e) {
					bRes = false;
					}
				}

				// -2
				try{
					obReg.requestPollInterval((short) -2);
				}
				catch (ToolkitException e){
					bRes = bRes && (e.getReason()==ToolkitException.REGISTRY_ERROR);
				}
				catch (Exception e) {
					bRes = false;
				}

				reportTestOutcome(testCaseNb, bRes) ;

				// -----------------------------------------------------------------
				// Test Case 6 :	Requesting POLL_NO_DURATION
				//					1-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return true
				//					2-	requestPollInterval(POLL_NO_DURATION)
				//						No exception shall be thrown
				//					3-	isEventSet(EVENT_STATUS_COMMAND
				//						Shall return false
				// -----------------------------------------------------------------
		
				testCaseNb = (byte) 6;
				bRes = false;
		
				// -----------------------------------------------------------------
				//					1-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return true
				// -----------------------------------------------------------------
				
				bRes = obReg.isEventSet(EVENT_STATUS_COMMAND);
				
				if (bRes){

				// -----------------------------------------------------------------
				//					2-	requestPollInterval(POLL_NO_DURATION)
				//						No exception shall be thrown
				// -----------------------------------------------------------------
		
				bRes = false;

					try{
						obReg.requestPollInterval(POLL_NO_DURATION);
						bRes = true;
					}
					catch (Exception e){
						bRes = false;
					}
				}
		
				// -----------------------------------------------------------------
				//					3-	isEventSet(EVENT_STATUS_COMMAND)
				//						Shall return false
				// -----------------------------------------------------------------
		
				bRes = bRes && !obReg.isEventSet(EVENT_STATUS_COMMAND);

				reportTestOutcome(testCaseNb, bRes) ;

				// -----------------------------------------------------------------
				// Test Case 7 :	Check Applet isn't triggered by an STATUS command
				//					True by default
				// -----------------------------------------------------------------

				reportTestSuccess((byte) 7);
	
			}  // End switch
		} 
		else{
			if (event == EVENT_STATUS_COMMAND) {
	
				switch (CallNB) {

				case (short) 1 :

					// -----------------------------------------------------------------
					// Test Case 2 :	Check Applet is triggered by a STATUS command
					//					True
					// -----------------------------------------------------------------

					reportTestSuccess((byte) 2);

					break;

				case (short) 2 :

					// -----------------------------------------------------------------
					// Test Case 4 :	Check Applet is triggered by a STATUS command
					//					True
					// -----------------------------------------------------------------

					reportTestSuccess((byte) 4);

					break;

				case (short) 3 :

					// -----------------------------------------------------------------
					// Test Case 7 :	Check Applet isn't triggered by an STATUS command
					//					False
					// -----------------------------------------------------------------

					reportTestFailure((byte) 7);
				}
			}
		}
	}
}
