//-----------------------------------------------------------------------------
//    API_2_ENH_FACRBBS_BSS_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_facrbbs_bss;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;
//import javacard.framework.Util.* ;
/**
 * Test Area : sim.tookit.EnvelopeHandler.findAndCompareValue()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 28/07/00
 *
 */
public class API_2_ENH_FACRBBS_BSS_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    //private ToolkitRegistry obReg;
	
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};
	
	private byte[] compBuffer;
	
    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_ENH_FACRBBS_BSS_1 () 
    {
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_FACRBBS_BSS_1  thisApplet = new API_2_ENH_FACRBBS_BSS_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
		ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
			case (byte) 0 : 
				// --------------------------------------------
				// Test Case 1 : try to use the findAndCompareValue methode with an destination Buffer null
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,null,(short)0,(short)1)==0)
							bRes = false;
				}
				catch (ToolkitException e)    {
					bRes = false;
				}
				catch (NullPointerException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 1 : 
				// --------------------------------------------
				// Test Case 2 : use the findAndCompareValue methode with an CompareOffset > buffer length
				testCaseNb = (byte) 2 ;

				bRes = false ;
				compBuffer =new byte[6];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)6,(short)1)==0)
						bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 2 : 
				// --------------------------------------------
				// Test Case 3 : use the findAndCompareValue methode with an CompareOffset <0
				testCaseNb = (byte) 3 ;

				bRes = false ;
				compBuffer =new byte[6];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)-1,(short)1)==0)
						bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
		
			case (byte) 3 : 
				// --------------------------------------------
				// Test Case 4 : use the findAndCompareValue methode with an Comparelength > buffer length
				testCaseNb = (byte) 4 ;
				
				bRes = false ;
				compBuffer =new byte[5];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)0,(short)6)==0)
						bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 4 : 
				// --------------------------------------------
				// Test Case 5 : use the findAndCompareValue methode with an CompareOffset + Comparelength > buffer length
				testCaseNb = (byte) 5 ;
				
				bRes = false ;
				compBuffer =new byte[5];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)3,(short)3)==0)
						bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 5 : 
				// --------------------------------------------
				// Test Case 6 : use the findAndCompareValue methode with an comparelength <0
				testCaseNb = (byte) 6 ;
				
				bRes = false ;
				compBuffer =new byte[5];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)0,(short)-1)==0)
						bRes = false;
				}
				catch (ArrayIndexOutOfBoundsException e)    {    
					bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 6 : 
				// --------------------------------------------
				// Test Case 7 : use the findAndCompareValue methode with an ValueOffset>ValueLength
				testCaseNb = (byte) 7 ;
				
				bRes = false ;
				compBuffer =new byte[15];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)6,compBuffer,(short)0,(short)1)==0)
						bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			
			
			case (byte) 7 : 
				// --------------------------------------------
				// Test Case 8 : use the findAndCompareValue methode with an ValueOffset<0
				testCaseNb = (byte) 8 ;
				
				bRes = false ;
				compBuffer =new byte[15];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)-1,compBuffer,(short)0,(short)1)==0)
						bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 8 : 
				// --------------------------------------------
				// Test Case 9 : use the findAndCompareValue methode with an CompareLength>ValueLength
				testCaseNb = (byte) 9 ;
				
				bRes = false ;
				compBuffer =new byte[15];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)0,(short)7)==0)
						bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			
			
			case (byte) 9 : 
				// --------------------------------------------
				// Test Case 10 : use the findAndCompareValue methode with an ValueOffset+comparelength>ValueLength
				testCaseNb = (byte) 10 ;
				
				bRes = false ;
				compBuffer =new byte[15];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)2,compBuffer,(short)0,(short)5)==0)
						bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.OUT_OF_TLV_BOUNDARIES)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 10 : 
				// --------------------------------------------
				// Test Case 11 : use the findAndCompareValue methode with occurence = 0
				testCaseNb = (byte) 11 ;
				
				bRes = false ;
				compBuffer =new byte[15];
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)0,(short)0,compBuffer,(short)0,(short)1)==0)
						bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.BAD_INPUT_PARAMETER)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;


			case (byte) 11 : 
				// --------------------------------------------
				// Test Case 12 : use the findAndCompareValue methode with a bad TAG
				testCaseNb = (byte) 12 ;
				
				bRes = false ;
				compBuffer =new byte[6];
				try {
					if((envHdlr.findTLV((byte)0x02,(byte)1)==TLV_FOUND_CR_NOT_SET)
					   &&(envHdlr.findAndCompareValue((byte)6,(byte)2,(short)0,compBuffer,(short)0,(short)1)==0))
							bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.UNAVAILABLE_ELEMENT)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				
				// use the methode getValueLength() after the unsuccessful of the methode findAndCompareValue 
				testCaseNb = (byte) 13 ;
				bRes = false;
				try {
					if(envHdlr.getValueLength()==0)
							bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.UNAVAILABLE_ELEMENT)
						bRes = true ;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 13 : 
				// --------------------------------------------
				// Test Case 13 : normal execution of the findAndCompareValue methode with the TAG 06
				testCaseNb = (byte) 14 ;
				
				bRes = false ;
				compBuffer =new byte[6];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x81;
				compBuffer[1]=(byte)0x11;
				compBuffer[2]=(byte)0x22;
				compBuffer[3]=(byte)0x33;
				compBuffer[4]=(byte)0x44;
				compBuffer[5]=(byte)0xF5;

				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)0,(short)6)==0)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			
			
			
			case (byte) 14 : 
				// --------------------------------------------
				// Test Case 14 : normal execution of the findAndCompareValue methode with the TAG 06 and verify the normal execution of the getValueLength()
				testCaseNb = (byte) 15 ;
				
				bRes = false ;
				compBuffer =new byte[6];
			
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x81;
				compBuffer[1]=(byte)0x11;
				compBuffer[2]=(byte)0x22;
				compBuffer[3]=(byte)0x33;
				compBuffer[4]=(byte)0x44;
				compBuffer[5]=(byte)0xF5;

				try {
					if((envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)0,(short)6)==0)
						&&(envHdlr.getValueLength()==6))
							bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			
			
			case (byte) 15 : 
				// --------------------------------------------
				// Test Case 15 : normal execution of the findAndCompareValue methode with comparaison buffer values < TLV values
				testCaseNb = (byte) 16 ;
				
				bRes = false ;
				compBuffer =new byte[6];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x81;
				compBuffer[1]=(byte)0x11;
				compBuffer[2]=(byte)0x22;
				compBuffer[3]=(byte)0x33;
				compBuffer[4]=(byte)0x44;
				compBuffer[5]=(byte)0xF4;

				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)0,(short)6)==+1)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 16 : 
				// --------------------------------------------
				// Test Case 16 : normal execution of the findAndCompareValue methode with comparaison buffer values > TLV values
				testCaseNb = (byte) 17 ;
				
				bRes = false ;
				compBuffer =new byte[6];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x81;
				compBuffer[1]=(byte)0x11;
				compBuffer[2]=(byte)0x22;
				compBuffer[3]=(byte)0x33;
				compBuffer[4]=(byte)0x44;
				compBuffer[5]=(byte)0xF6;

				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)0,compBuffer,(short)0,(short)6)==-1)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 17 : 
				// --------------------------------------------
				// Test Case 17 : normal execution of the findAndCompareValue methode (compare with un fulfilled buffer) TAG = 06
				testCaseNb = (byte) 18 ;
				
				bRes = false ;
				compBuffer =new byte[11];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x55;
				compBuffer[1]=(byte)0x55;
				compBuffer[2]=(byte)0x55;
				compBuffer[3]=(byte)0x22;
				compBuffer[4]=(byte)0x33;
				compBuffer[5]=(byte)0x44;
				compBuffer[6]=(byte)0xF5;
				compBuffer[7]=(byte)0x55;
				compBuffer[8]=(byte)0x55;
				compBuffer[9]=(byte)0x55;
				compBuffer[10]=(byte)0x55;
				
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)2,compBuffer,(short)3,(short)4)==0)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 18 : 
				// --------------------------------------------
				// Test Case 18 : normal execution of the findAndCompareValue methode  (compare with un fulfilled buffer) TAG = 02
				//                the compared buffer is > tlv values
				testCaseNb = (byte) 19 ;
				
				bRes = false ;
				compBuffer =new byte[11];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x55;
				compBuffer[1]=(byte)0x55;
				compBuffer[2]=(byte)0x55;
				compBuffer[3]=(byte)0x22;
				compBuffer[4]=(byte)0x33;
				compBuffer[5]=(byte)0x45;
				compBuffer[6]=(byte)0xF5;
				compBuffer[7]=(byte)0x55;
				compBuffer[8]=(byte)0x55;
				compBuffer[9]=(byte)0x55;
				compBuffer[10]=(byte)0x55;
				
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)2,compBuffer,(short)3,(short)4)==-1)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 19 : 
				// --------------------------------------------
				// Test Case 19 : normal execution of the findAndCompareValue methode  (compare with un fulfilled buffer) TAG = 02
				//                the compared buffer is < tlv values
				testCaseNb = (byte) 20 ;
				
				bRes = false ;
				compBuffer =new byte[11];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x55;
				compBuffer[1]=(byte)0x55;
				compBuffer[2]=(byte)0x55;
				compBuffer[3]=(byte)0x22;
				compBuffer[4]=(byte)0x33;
				compBuffer[5]=(byte)0x43;
				compBuffer[6]=(byte)0xF5;
				compBuffer[7]=(byte)0x55;
				compBuffer[8]=(byte)0x55;
				compBuffer[9]=(byte)0x55;
				compBuffer[10]=(byte)0x55;
				
				try {
					if(envHdlr.findAndCompareValue((byte)6,(byte)1,(short)2,compBuffer,(short)3,(short)4)==+1)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 20 : 
				// --------------------------------------------
				// Test Case 20 : normal execution of the findAndCompareValue methode  (compare with un fulfilled buffer) TAG = 02
				testCaseNb = (byte) 21 ;
				
				bRes = false ;
				compBuffer =new byte[12];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x83;
				compBuffer[1]=(byte)0x81;
				
				for(byte i=2;i<12;i++)
					compBuffer[i]=(byte)0x55;
				
				
				try {
					if(envHdlr.findAndCompareValue((byte)2,(byte)1,(short)0,compBuffer,(short)0,(short)2)==0)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;


			case (byte) 21 : 
				// --------------------------------------------
				// Test Case 21 : normal execution of the findAndCompareValue methode  (compare with un fulfilled buffer) TAG = 02 and 2 occurence
				testCaseNb = (byte) 22 ;
				
				bRes = false ;
				compBuffer =new byte[12];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x22;
				compBuffer[1]=(byte)0x44;
				
				for(byte i=2;i<12;i++)
					compBuffer[i]=(byte)0x55;
				
				try {
					if(envHdlr.findAndCompareValue((byte)2,(byte)2,(short)0,compBuffer,(short)0,(short)2)==0)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 22 : 
				// --------------------------------------------
				// Test Case 22 : normal execution of the findAndCompareValue methode  (compare with un fulfilled buffer) TAG = 02 and 2 occurence 
				//                the compared buffer is < tlv values
				testCaseNb = (byte) 23 ;
				
				bRes = false ;
				compBuffer =new byte[12];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x22;
				compBuffer[1]=(byte)0x45;
				
				for(byte i=2;i<12;i++)
					compBuffer[i]=(byte)0x55;
				
				try {
					if(envHdlr.findAndCompareValue((byte)2,(byte)2,(short)0,compBuffer,(short)0,(short)2)==-1)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			
			case (byte) 23 : 
				// --------------------------------------------
				// Test Case 23 : normal execution of the findAndCompareValue methode  (compare with un fulfilled buffer) TAG = 02 and 1 occurence
				testCaseNb = (byte) 24 ;
				
				bRes = false ;
				compBuffer =new byte[12];
				
				//initialization of the comparaison buffer
				compBuffer[0]=(byte)0x83;
				compBuffer[1]=(byte)0x81;
				
				for(byte i=2;i<12;i++)
					compBuffer[i]=(byte)0x55;
				
				try {
					if(envHdlr.findAndCompareValue((byte)2,(byte)1,(short)0,compBuffer,(short)0,(short)2)==0)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;
			
			case (byte) 24 : 
				// --------------------------------------------
				// Test Case 24 : normal execution of the findAndCompareValue methode  (compare with un fulfilled buffer) TAG = B3
				testCaseNb = (byte) 25 ;
				
				bRes = false ;
				compBuffer =new byte[0xC4];
				for(short i=0;i<0x00C4;i++)
					compBuffer[i]=(byte)(i+1);
								
				try {
					if(envHdlr.findAndCompareValue((byte)0xB3,(byte)1,(short)0,compBuffer,(short)0,(short)compBuffer.length)==0)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 25 : 
				// --------------------------------------------
				// Test Case 25 : normal execution of the findAndCompareValue methode  (with length = 0 and offset = length of the comparaison buffer)
				testCaseNb = (byte) 26 ;
				
				bRes = false ;
				try {
					if(envHdlr.findAndCompareValue((byte)0xB3,(byte)1,(short)0,compBuffer,(short)compBuffer.length,(short)0)==0)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

		}
	}
}
