//-----------------------------------------------------------------------------
//    API_2_ENH_GENT_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_enh_gent;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeHandler.getEnvelopeTag
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 28/07/00
 *
 */
public class API_2_ENH_GENT_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;
	
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

    /**
     * Constructor of the applet
     */
    public API_2_ENH_GENT_1 () 
    {

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ENH_GENT_1  thisApplet = new API_2_ENH_GENT_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        // Get the system instance of handlers
		EnvelopeHandler envHdlr = EnvelopeHandler.getTheHandler();
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    // --------------------------------------------
        // Test Case 1 : getEnvelopeTag called just after triggering of the application.
        testCaseNb = (byte) 1 ;

        bRes = false ;
        try {
			if (envHdlr.getEnvelopeTag() == BTAG_SMS_PP_DOWNWLOAD)
				bRes = true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

	    // --------------------------------------------
        // Test Case 2 : getEnvelopeTag called after a proactive command.
        testCaseNb = (byte) 2 ;

        bRes = false ;
        try {
			proHdlr.initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
			proHdlr.send();
			if (envHdlr.getEnvelopeTag() == BTAG_SMS_PP_DOWNWLOAD)
				bRes = true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

	    // --------------------------------------------
        // Test Case 3 : getEnvelopeTag called after a second proactive command.
        testCaseNb = (byte) 3 ;

        bRes = false ;
        try {
			proHdlr.initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
			proHdlr.send();
			if (envHdlr.getEnvelopeTag() == BTAG_SMS_PP_DOWNWLOAD)
				bRes = true;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

	}
}
