//-----------------------------------------------------------------------------
//    API_2_ERH_GTHD_1 .java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_erh_gthd;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.tookit.EnvelopeResponseHandler.getTheHandler()
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.1 - 28/07/00
 *
 */
public class API_2_ERH_GTHD_1  extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    //private ToolkitRegistry obReg;
	
	private static byte[] displayString = {(byte)'H', (byte)'E', (byte)'L', (byte)'L', (byte)'O'};

	private static EnvelopeResponseHandler envRespHdlr3;
	private EnvelopeResponseHandler envRespHdlr4;

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_ERH_GTHD_1 () 
    {

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_ERH_GTHD_1  thisApplet = new API_2_ERH_GTHD_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

		
        

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Get the system instance of handlers
		ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
	    switch ( testCaseNb ) 
		{
			case (byte) 0 :
				// --------------------------------------------
				// Test Case 1 : use th methode getTheHandler() Twice 
				testCaseNb = (byte) 1 ;

				bRes = false ;
				try {
					EnvelopeResponseHandler envRespHdlr1 = EnvelopeResponseHandler.getTheHandler();
					EnvelopeResponseHandler envRespHdlr2 = EnvelopeResponseHandler.getTheHandler();
        
					if (envRespHdlr1==envRespHdlr2 )
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 1 :
				// --------------------------------------------
				// Test Case 2 : verify that the methode getTheHandler return EnvelopeResponseHandler reference
				testCaseNb = (byte) 2 ;

				bRes = false ;
				try {
					EnvelopeResponseHandler envRespHdlr1 = EnvelopeResponseHandler.getTheHandler();
					
					if (envRespHdlr1 instanceof EnvelopeResponseHandler)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 2 :
				// --------------------------------------------
				// Test Case 3 : verify that the methode getTheHandler does not return NULL
				testCaseNb = (byte) 3 ;

				bRes = false ;
				try {
					EnvelopeResponseHandler envRespHdlr1 = EnvelopeResponseHandler.getTheHandler();
					
					if (envRespHdlr1!=null)
						bRes = true;
				}
				catch (Exception e)    {    
					bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

			case (byte) 3 :
				// --------------------------------------------
				// Test Case 4 : use the getTheHandler methode when a proacxtive commamd is already send
				testCaseNb = (byte) 4 ;

				bRes = false ;
				try {
					//send the proactive command
					proHdlr.initDisplayText((byte)0x80, DCS_8_BIT_DATA, displayString, (short) 0, (short) displayString.length);
					proHdlr.send();
					
					//use the methode getTheHandler when the command is suspended
					EnvelopeResponseHandler envRespHdlr = EnvelopeResponseHandler.getTheHandler();
					bRes = false;
				}
				catch (ToolkitException e)    {    
					if(e.getReason()==ToolkitException.HANDLER_NOT_AVAILABLE)
						bRes = true ;
				}
				catch (Exception e)    {    
						bRes = false ;
				}
				reportTestOutcome(testCaseNb, bRes) ;
				break;

		}
	}
}
