//-----------------------------------------------------------------------------
//    API_2_MEP_CHECS_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_mep_checs;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.*;
import javacard.framework.*;
import sim.test.util.*;

/**
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV, EVENT_STATUS_COMMAND
 *
 *
 */

public class API_2_MEP_CHECS_1  extends TestToolkitApplet
{

    // Number of tests
    byte testCaseNb = (byte) 0x00;
        
	/**
     * Constructor of the applet
     */
    public API_2_MEP_CHECS_1 () 
    {
		// Set Status Command as an activation event for the applet
		obReg.requestPollInterval(POLL_SYSTEM_DURATION);
	}


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_MEP_CHECS_1  thisApplet = new API_2_MEP_CHECS_1 ();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
     * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes;
                
		if (event == EVENT_STATUS_COMMAND)
		{
		    /** Test Case 1 : ToolkitException ME_PROFILE_NOT_AVAILABLE is sent */
			testCaseNb = (byte) 1;
			bRes = false;
			try 
			{
				MEProfile.check((short)1);
			}
			catch (ToolkitException e) 
			{
				if (e.getReason() == ToolkitException.ME_PROFILE_NOT_AVAILABLE) 
				{
					bRes = true;
				}
			}
			catch (Exception e) 
			{
         		  bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);
		}

		if (event == EVENT_FORMATTED_SMS_PP_ENV) 
		{

			/** Test Case 2 : Facility is supported */
			testCaseNb = (byte)2;
			bRes = false;
			try 
			{
				bRes = MEProfile.check((short)0);
			}
			catch (Exception e) 
			{
				bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);

            /** Test Case 3 : Facility is not supported */
			testCaseNb = (byte)3;
			bRes = false;

			try 
			{
				if (MEProfile.check((short)15)==false) 
				{
					bRes = true;
				}
				else 
				{
					bRes = false;
				}
			}
			catch (Exception e) 
			{
				bRes = false;
			}
			reportTestOutcome(testCaseNb, bRes);

            /** Test Case 4 : Facility is outside MEProfile data  */
			testCaseNb = (byte)4;
			bRes = false;

			try 
			{
				if (MEProfile.check((short)0x0099)==false) 
				{
					bRes = true;
				}
				else 
				{
					bRes = false;
				}
			}
			catch (Exception e) 
			{
				bRes = false;
			}
			reportTestOutcome(testCaseNb, bRes);

		    /** Test Case 5 : ToolkitException BAD_INPUT_PARAMETER is sent */
			testCaseNb = (byte) 5;
			bRes = false;
			try 
			{
				MEProfile.check((short)0x8001);
			}
			catch (ToolkitException e) 
			{
				if (e.getReason() == ToolkitException.BAD_INPUT_PARAMETER) 
				{
					bRes = true;
				}
			}
			catch (Exception e) 
			{
         		  bRes = false;
			}

			reportTestOutcome(testCaseNb, bRes);
		}
	}
}
