//-----------------------------------------------------------------------------
//    API_2_PAH_GLEN_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_pah_glen;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ProactiveHandler.getLength() method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 07/12/00
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.ProactiveHandler
 */
public class API_2_PAH_GLEN_1 extends TestToolkitApplet
{

    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;

    private byte[] LONG_TEXT = new byte[240] ;

    /**
     * Constructor of the applet
     */
    public API_2_PAH_GLEN_1() 
    {

    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_PAH_GLEN_1 thisApplet = new API_2_PAH_GLEN_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {
        // Result of tests
        boolean bRes ;
        
        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        // Get the system instance of the ProactiveHandler class
        ProactiveHandler proHdlr = ProactiveHandler.getTheHandler() ;
        
        
        // --------------------------------------------
        // Test Case 1 : length = 0
        testCaseNb = (byte) 1 ;
        bRes = false ;
        
        try {
            
            proHdlr.clear() ;
            
            bRes = (proHdlr.getLength() == (short)0) ;
            
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;

        // --------------------------------------------
        // Test Case 2 : length = 9
        testCaseNb = (byte) 2 ;
        bRes = false ;
        
        try {
            
            proHdlr.init((byte)0, (byte)0, (byte)0) ;
            
            bRes = (proHdlr.getLength() == (short)9) ;
            
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 3 : length = 253
        testCaseNb = (byte) 3 ;
        bRes = false ;
        
        try {
            
            proHdlr.initDisplayText((byte)0, (byte)4, LONG_TEXT, (short)0, (short)LONG_TEXT.length) ;
            
            bRes = (proHdlr.getLength() == (short)253) ;
            
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;



        // --------------------------------------------
        // Test Case 4 : length = 7Fh
        testCaseNb = (byte) 4 ;
        bRes = false ;
        
        try {
            
            // Build a 7Fh byte command
            proHdlr.initDisplayText((byte)0, (byte)4, LONG_TEXT, (short)0, (short)(0x7F-12)) ;
            
            bRes = (proHdlr.getLength() == (short)0x7F) ;
            
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


        // --------------------------------------------
        // Test Case 5 : length = 80h
        testCaseNb = (byte) 5 ;
        bRes = false ;
        
        try {
            
            // Build a 80h byte command
            proHdlr.initDisplayText((byte)0, (byte)4, LONG_TEXT, (short)0, (short)(0x80-12)) ;
            
            bRes = (proHdlr.getLength() == (short)0x80) ;
            
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;


    }
}
