//-----------------------------------------------------------------------------
//    API_2_PRH_GTHD_1.java
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//    Package Definition
//-----------------------------------------------------------------------------
package sim.test.toolkit.api_2_prh_gthd;

//-----------------------------------------------------------------------------
//    Imports
//-----------------------------------------------------------------------------
import sim.toolkit.* ;
import javacard.framework.* ;
import sim.test.util.* ;

/**
 * Test Area : sim.toolkit.ProactiveResponseHandler.getTheHandler() method
 * 
 * Applet is triggered on Install (Install), EVENT_FORMATTED_SMS_PP_ENV
 *
 * @version 0.0.2 - 07/12/00
 * @author 3GPP T3 SWG API
 *
 * @see sim.toolkit.ProactiveResponseHandler
 */
public class API_2_PRH_GTHD_1 extends TestToolkitApplet
{

    private byte[] text = {(byte)'T',(byte)'e',(byte)'x',(byte)'t'} ;
    
    /** Registry entry concerning applet instance */
    private ToolkitRegistry oReg;

    /** Instance field used to verify the SecurityException */
    
    private ProactiveResponseHandler instanceProRespHdlr ;
    
    /** Static field used to verify the SecurityException */
    
    private static ProactiveResponseHandler staticProRespHdlr ;

    /**
     * Constructor of the applet
     */
    public API_2_PRH_GTHD_1() 
    {
    }


    /**
     * Method called by the JCRE at the installation of the applet
     */
    public static void install(byte bArray[], short bOffset, byte bLength) 
    {
        // Create a new applet instance
        API_2_PRH_GTHD_1 thisApplet = new API_2_PRH_GTHD_1();

        // Register the new applet instance to the JCRE            
        thisApplet.register(bArray, (short)(bOffset+1), bArray[bOffset]);

        // Initialise the data of the test applet
        thisApplet.init();    
    }
    

    /**
       * Method called by the SIM Toolkit Framework
     */
    public void processToolkit(byte event) 
    {

        // Result of tests
        boolean bRes ;
        
        // Number of tests
        byte testCaseNb = (byte) 0x00 ;
        
        ProactiveResponseHandler proRespHdlr ;
        ProactiveResponseHandler proRespHdlr1 ;
        ProactiveResponseHandler proRespHdlr2 ;
        ProactiveHandler proHdlr ;
     
        // --------------------------------------------
        // Test Case 1 : getTheHandler() twice
        testCaseNb = (byte) 1 ;
        bRes = false ;
            
        try {
            
            // Build and send a Proactive command
            proHdlr = ProactiveHandler.getTheHandler() ;
            proHdlr.initDisplayText((byte)0x00, DCS_8_BIT_DATA, text, (short)0, (short)text.length) ;
            proHdlr.send() ;
            
            proRespHdlr1 = ProactiveResponseHandler.getTheHandler() ;
            proRespHdlr2 = ProactiveResponseHandler.getTheHandler() ;
                
            bRes = (proRespHdlr1 == proRespHdlr2) ;
                
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
            
        // --------------------------------------------
        // Test Case 2 : the reference shall be a ProactiveResponseHandler
        testCaseNb = (byte) 2 ;
        bRes = false ;
            
        try {
            proRespHdlr = ProactiveResponseHandler.getTheHandler() ;
                
            bRes = (proRespHdlr instanceof ProactiveResponseHandler) ;
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
            

        // --------------------------------------------
        // Test Case 3 : the reference shall not be null
        testCaseNb = (byte) 3 ;
        bRes = false ;
            
        try {
            proRespHdlr = ProactiveResponseHandler.getTheHandler() ;
                
            if (proRespHdlr == null) {
                bRes = false ;
            } else {
                bRes = true ;
            }
        }
        catch (Exception e)    {    
            bRes = false ;
        }
        reportTestOutcome(testCaseNb, bRes) ;
            

           

    }
    
}
